<template>
  <div class="summary-container">
    <ObTable
      ref="summaryTable"
      :columns="columns"
      :filter-buttons="filterButtons"
      :functional-panel="!!winnerScenario"
      :remote-opt="{
        method: fetchSummary,
        contentKey: viewFilterKey
      }"
      @select="openRowInfo"
      :show-hidden-length="true"
      @on-change-filter-button="onChangeFilterButton"
      @on-load-list="onTableLoaded"
      :filters-handler="filtersHandler"
      :class="[ 'summary-table', viewFilter.toLowerCase(), { 'is-rows-blue': viewFilter !== 'ByValues' } ]"
      :is-functional-sort="false"
      :is-functional-group="false"
      :is-functional-search="false"
      :tableLayoutFixed="true"
      data-qa="summaryTable"
      is-fixed-header
    >
      <template slot="controls">
        <TmsPolicy
          v-if="['SUMMARIZING', 'COMPLETED'].includes(tender.status)"
          :tender="tender"
          :is-compact="true"
          class="tms-policy-button"
        />
      </template>

      <template slot="extraFuncToPanel">
        <ObMenuDropdown
          :items="excelDropdownItems"
          icon="excel"
        />
      </template>

      <template slot="deficit-indicator" slot-scope="{ data }">
        <span :class="{ 'text-red': data.item.deficitIndicator < 0 }">
          {{ data.item.deficitIndicator }}
        </span>
      </template>
    </ObTable>

    <InfoBar :source="summary" />

    <ObModal
      size="max"
      ok-text="Закрыть"
      :title="lotViewSummaryModalTitle"
      :is-show-controls="true"
      :is-read-only="true"
      ref="viewLotSummary"
      data-qa="summaryModal"
      @submit="closeLotSummary"
    >
      <viewLotSummary
        :tender-uuid="tender.uuid"
        :scenario-uuid="winnerScenario ? winnerScenario.uuid : ''"
        :row-data="selectedRow"
      />
    </ObModal>

    <ObModal
      v-if="viewFilter === 'ByCarriers'"
      size="medium"
      ok-text="Закрыть"
      :title="participantInfoModalTitle"
      :is-show-controls="true"
      :is-read-only="true"
      ref="participantInfo"
      data-qa="participantsModal"
      @submit="closeLotSummary"
    >
      <participantInfo
        :uuid="selectedRow ? selectedRow.uuid : ''"
      />
    </ObModal>

    <SuccessExport
      ref="successExportModal"
      :data-source="exportResult"
    />
  </div>
</template>

<script>
  import ObTable from 'common-components/src/obComponents/obTable'
  import ObModal from 'common-components/src/obComponents/obModal'
  import viewLotSummary from './modal/viewLotSummary'
  import participantInfo from './modal/participantInfo'
  import ExportExcel from '../../mixins/export-excel'
  import FiltersSupport from '../../../../mixins/filtersSupport'
  import InfoBar from '../../../components/infoBar'
  import TmsPolicy from '../../../components/tmsPolicy'
  import api from '@/api'

  export default {
    name: 'tender-tab-buyer-summary-rfq',
    mixins: [
      ExportExcel,
      FiltersSupport
    ],
    components: {
      ObTable,
      ObModal,
      viewLotSummary,
      participantInfo,
      InfoBar,
      TmsPolicy
    },
    data () {
      return {
        api,
        filterButtons: [
          {
            title: 'Все предложения',
            key: 'variantValues',
            type: 'ByValues'
          },
          {
            title: 'По лотам',
            key: 'variantsByLots',
            type: 'ByLots'
          },
          {
            title: 'По поставщикам',
            key: 'carriers',
            type: 'ByCarriers'
          }
        ],
        winnerScenario: null,
        lotViewSummaryModalTitle: '',
        participantInfoModalTitle: '',
        viewFilter: 'ByValues',
        viewFilterKey: 'variantValues',
        filterButtonWasChanged: null,
        summary: [],
        selectedRow: null,
        exportResult: null,
        columnsByValues: [
          {
            title: '№ Лота',
            key: 'number',
            isAlignRight: true,
            exactWidth: '61px'
          },
          {
            key: 'fromPlaceTitle',
            title: 'Откуда',
            subtitle: 'Описание',
            withFilter: true,
            headerHtml: ({ title, subtitle }) => this.getHeader(title, subtitle)
          },
          {
            key: 'toPlaceTitle',
            title: 'Куда',
            subtitle: 'Описание',
            withFilter: true,
            headerHtml: ({ title, subtitle }) => this.getHeader(title, subtitle)
          },
          {
            key: 'resourceTypeTitle',
            title: 'Ресурс',
            subtitle: 'Тип ТС',
            headerHtml: ({ title, subtitle }) => this.getHeader(title, subtitle)
          },
          {
            title: 'Грузоподъёмность, т',
            key: 'carriageCount',
            isAlignRight: true
          },
          {
            title: 'Поставщик',
            key: 'carrierTitle',
            withFilter: true,
            sortDisable: true
          },
          {
            title: 'Ставка, пост-ка ₽',
            key: 'bid',
            isAlignRight: true,
            sortDisable: true
          },
          {
            title: 'Квота в лоте',
            key: 'carrierCarriageQuote',
            isAlignRight: true,
            sortDisable: true
          },
          {
            title: 'Сумма затрат в лоте, ₽',
            key: 'cost',
            isAlignRight: true,
            sortDisable: true
          },
          {
            title: 'Доля в объеме, %',
            key: 'percentInTotalVolume',
            isAlignRight: true,
            sortDisable: true
          },
          {
            title: 'Доля в затр., %',
            key: 'partInTotalCosts',
            isAlignRight: true,
            sortDisable: true
          }
        ],
        columnsByLots: [
          {
            title: '№ Лота',
            key: 'number',
            isAlignRight: true,
            exactWidth: '61px',
            html: (data) => this.getStyledFieldValue(data.number)
          },
          {
            key: 'fromPlaceTitle',
            title: 'Откуда',
            subtitle: 'Описание',
            withFilter: true,
            headerHtml: ({ title, subtitle }) => this.getHeader(title, subtitle),
            html: (data) => this.getStyledFieldValue(data.fromPlaceTitle)
          },
          {
            key: 'toPlaceTitle',
            title: 'Куда',
            subtitle: 'Описание',
            withFilter: true,
            headerHtml: ({ title, subtitle }) => this.getHeader(title, subtitle),
            html: (data) => this.getStyledFieldValue(data.toPlaceTitle)
          },
          {
            key: 'resourceTypeTitle',
            title: 'Ресурс',
            subtitle: 'Тип ТС',
            headerHtml: ({ title, subtitle }) => this.getHeader(title, subtitle),
            html: (data) => this.getStyledFieldValue(data.resourceTypeTitle)
          },
          {
            title: 'Грузоподъёмность, т',
            key: 'carriageCount',
            isAlignRight: true,
            html: (data) => this.getStyledFieldValue(data.carriageCount)
          },
          {
            title: 'Индик-р дефицита',
            key: 'deficitIndicator',
            isAlignRight: true,
            slotName: 'deficit-indicator',
            sortDisable: true
          },
          {
            title: 'Min ставка',
            key: 'minBid',
            isAlignRight: true,
            sortDisable: true
          },
          {
            title: 'Max ставка',
            key: 'maxBid',
            isAlignRight: true,
            sortDisable: true
          },
          {
            title: 'Вес лота, %',
            key: 'lotWeight',
            isAlignRight: true,
            sortDisable: true
          },
          {
            title: 'Выбрано пост-в в лоте',
            key: 'carrierCount',
            isAlignRight: true,
            sortDisable: true
          },
          {
            title: 'Сумма затрат по лоту, ₽',
            key: 'lotCost',
            isAlignRight: true,
            sortDisable: true
          }
        ],
        columnsByCarriers: [
          {
            key: 'title',
            title: 'Поставщик',
            withFilter: true,
            html: (data) => this.getStyledFieldValue(data.title)
          },
          {
            title: 'Участвует в лотах',
            key: 'partTakeLotsCount',
            isAlignRight: true
          },
          {
            title: 'Не участвует в лотах',
            key: 'noPartTakeLotsCount',
            isAlignRight: true
          },
          {
            title: 'Лотов с гар. объемом',
            key: 'guaranteedPurchaseVolumeLotsCount',
            isAlignRight: true
          },
          {
            title: 'Дефицитных лотов',
            key: 'deficitLotsCount',
            isAlignRight: true
          },
          {
            title: 'Квота во всех лотах',
            key: 'carriageQuoteSum',
            isAlignRight: true
          },
          {
            title: 'Сумма затрат на все лоты, ₽',
            key: 'costSum',
            isAlignRight: true
          },
          {
            title: 'Доля в общем объеме, %',
            key: 'partInTotalVolume',
            isAlignRight: true,
            html: (column) => this.roundFieldValue(column.partInTotalVolume)
          },
          {
            title: 'Доля в общих затратах, %',
            key: 'partInTotalCosts',
            isAlignRight: true,
            html: (column) => this.roundFieldValue(column.partInTotalCosts)
          }
        ]
      }
    },
    props: {
      tender: {
        type: Object,
        required: true
      }
    },
    computed: {
      lotHeaders () {
        return this.summary[0].lotHeaders
      },
      columns () {
        return this[`columns${this.viewFilter}`]
      }
    },
    methods: {
      async fetchSummary (args) {
        if (!this.winnerScenario) {
          const { scenarios } = await api.tendersScenarios.getTenderScenarios({ tenderUuid: this.tender.uuid })

          this.winnerScenario = scenarios.find(scenario => scenario.variantStatus === 'WINNER')

          if (!this.winnerScenario) {
            return [];
          }
        }

        const response = await api.tendersScenarios[`getTenderScenarioResult${this.viewFilter}`]({
          ...args,
          ...this.tableParameters,
          tenderUuid: this.tender.uuid,
          scenarioUuid: this.winnerScenario.uuid
        })

        this.summary = response[this.viewFilterKey]

        if (this.filterButtonWasChanged === true && this.summary?.[0]?.lotHeaders?.length) {
          this.filterButtonWasChanged = false

          let headers = this.summary[0].lotHeaders

          // First sort by categories, then sort columns in category
          headers = headers.sort((a, b) => {
            const result = a.categoryPos - b.categoryPos

            return result === 0 ? a.pos - b.pos : result
          })

          // Store headersUuid in the right order
          // to restoring it in table columns
          const headersPositions = headers.map(header => header.uuid)

          headers.forEach((header, i) => {
            this.columns.splice(i + 1, 0, {
              title: header.title,
              subtitle: header.categoryTitle,
              headerHtml: ({ title, subtitle }) => this.getHeader(title, subtitle),
              // Added checking '?.lotHeaders', because columns is changing
              // earlier than table data, and we got an error that 'lotHeaders'
              // is 'undefined', because some types can be without 'lotHeaders'
              html: (column) => column?.lotHeaders.find(header => header.uuid === headersPositions[i]).value
            })
          })
        }

        return response;
      },
      onTableLoaded () {
        // For tables 'by lots' and 'by carriers'
        if (this.viewFilter === 'ByValues') {
          return
        }

        setTimeout(() => {
          this.$refs.summaryTable.selectableItems.forEach((item) => {
            if (
              this.viewFilter === 'ByLots' && (item.item.deficitIndicator || !item.item.lotCost) ||
              this.viewFilter === 'ByCarriers' && (item.item.deficitLotsCount || !item.item.costSum)
            ) {
              this.$set(item, '_isSelected', true)
            }
          })
        }, 0)
      },
      openRowInfo (data) {
        if (this.viewFilter === 'ByLots') {
          this.lotViewSummaryModalTitle = `${data.number}. ${data.fromPlaceTitle} → ${data.toPlaceTitle} / ${data.resourceTypeTitle}`

          if (data.carriageCount) {
            this.lotViewSummaryModalTitle += ` / ${data.carriageCount}`
          }

          this.selectedRow = data

          this.$refs.viewLotSummary.open()
        } else if (this.viewFilter === 'ByCarriers') {
          this.participantInfoModalTitle = data.title || ''
          this.selectedRow = data

          this.$refs.participantInfo.open()
        }
      },
      closeLotSummary () {
        this.$refs.viewLotSummary.close()
      },
      getStyledFieldValue (value) {
        return `<div class="text-blue">${value !== '' && value !== null ? value : '—'}</div>`
      },
      getHeader (title, subtitle) {
        return subtitle ? `<div class="text-gray">${subtitle}</div>${title}` : title
      },
      onChangeFilterButton (data) {
        // Don't changing type if it's already set
        if (data.type === this.viewFilter) {
          return
        }

        this.filterButtonWasChanged = true

        this.viewFilter = data.type
        this.viewFilterKey = data.key

        this.$refs.summaryTable.loadData({
          init: true,
          sort: {
            key: null,
            type: null,
            direction: false
          }
        })
      },
      roundFieldValue (value) {
        if (!value) {
          return
        }

        return value.toFixed(2)
      },
      async exportToExcel () {
        this.exportResult = await api.tendersExcels.RFQSummary(this.tender.uuid)
      },
      reloadTable () {
        this.$refs.summaryTable.loadData({ init: true })
      }
    }
  }
</script>

<style lang="scss" scoped>
  .text-red {
    color: $color-error;
  }

  .tms-policy-button {
    margin: auto auto auto 10px;
  }

  ::v-deep {
    .text-gray {
      color: $color-grey-span;
    }

    .text-blue {
      color: $color-blue-navy-blue;
    }

    .summary-table {
      &.is-rows-blue .data-row:not(.row-selected) {
        background-color: $light-lavender;
      }

      tr.row-selected {
        background-color: rgba($gorse-yellow, .1);
      }

      @mixin change-column-bg($count, $opacity) {
        th, td {
          &:nth-last-of-type(-n + #{$count}) {
            // Using calc() to cast type from String to Number
            background-color: rgba(214, 226, 246, calc(#{$opacity})); // TODO use variables
          }
        }
      }

      @mixin alternative-hover {
        .data-row:hover {
          background-color: darken($light-lavender, 4%);
        }
      }

      &.byvalues {
        @include change-column-bg(4, 0.2);

        .data-row {
          cursor: auto;
        }
      }

      &.bylots {
        @include change-column-bg(2, 0.5);
        @include alternative-hover;
      }

      &.bycarriers {
        @include change-column-bg(4, 0.5);
        @include alternative-hover;
      }
    }
  }
</style>
